public class Polynom {
    private double[] koeffizienten;
    private int grad, aktuellerExponent;
    
    public Polynom () {
        koeffizienten = new double[10];
        for (int i=0; i<10; i++) koeffizienten[i]=0;
        grad = aktuellerExponent = 9;
    }
  
    /**
     * wird zur Definition der Koeffizienten aufgerufen.
     * hoehere Exponenten als der derzeit betrachtete Grad werden ignoriert.
     */
    public void definiereKoeffizienten(double a, int exponent){
        if (exponent<=aktuellerExponent){
            if (exponent<grad) grad=exponent;          // Grad neu setzen
            if (exponent<aktuellerExponent) aktuellerExponent=exponent;
            koeffizienten[exponent]= a;
            aktuellerExponent--;
        }
    }
  
    /**
     * gibt zu den Koeffizienten den Term zurck.
     */
    public String gibTerm(){
        StringBuffer term = new StringBuffer();
        for (int i=9;i>1;i--)
        if (koeffizienten[i]!=0) term = term.append(" + "+koeffizienten[i]+"x^"+i);
        if (koeffizienten[1]!=0) term = term.append(" + "+koeffizienten[1]+"x");
        if (koeffizienten[0]!=0) term = term.append(" + "+koeffizienten[0]);
        if (term.toString().equals("")) term=term.append(""+0);
        return term.toString();
    }
    
    /**
     * berechnet den Funktionswert an der bergebenen Stelle.
     * Prinzip: Horner-Schema
     */
    public double berechneWert(double x){
        double wert=koeffizienten[9];
        for (int i=8;i>=0;i--) wert=wert*x+koeffizienten[i];
        return wert;
    }
}

